package com.inator.calculator.model

import android.content.Context
import android.graphics.drawable.Drawable
import androidx.core.content.ContextCompat
import com.inator.calculator.R

//Thanks to sal0max for his awesome Currency Converter App
// Check out his app https://github.com/sal0max/currencies
data class Rate(
    val code: String,
    val value: Float
) {
    fun getName(context: Context): String? {
        return context.getString(
            when (code) {
                "AED" -> R.string.name_aed
                "AFN" -> R.string.name_afn
                "ALL" -> R.string.name_all
                "AMD" -> R.string.name_amd
                "ANG" -> R.string.name_ang
                "AOA" -> R.string.name_aoa
                "ARS" -> R.string.name_ars
                "AUD" -> R.string.name_aud
                "AWG" -> R.string.name_awg
                "AZN" -> R.string.name_azn
                "BAM" -> R.string.name_bam
                "BBD" -> R.string.name_bbd
                "BDT" -> R.string.name_bdt
                "BGN" -> R.string.name_bgn
                "BHD" -> R.string.name_bhd
                "BIF" -> R.string.name_bif
                "BMD" -> R.string.name_bmd
                "BND" -> R.string.name_bnd
                "BOB" -> R.string.name_bob
                "BRL" -> R.string.name_brl
                "BSD" -> R.string.name_bsd
                "BTC" -> R.string.name_btc
                "BTN" -> R.string.name_btn
                "BWP" -> R.string.name_bwp
                "BYN" -> R.string.name_byn
                "BZD" -> R.string.name_bzd
                "CAD" -> R.string.name_cad
                "CDF" -> R.string.name_cdf
                "CHF" -> R.string.name_chf
                "CLF" -> R.string.name_clf
                "CLP" -> R.string.name_clp
                "CNH" -> R.string.name_cnh
                "CNY" -> R.string.name_cny
                "COP" -> R.string.name_cop
                "CRC" -> R.string.name_crc
                "CUC" -> R.string.name_cuc
                "CUP" -> R.string.name_cup
                "CVE" -> R.string.name_cve
                "CZK" -> R.string.name_czk
                "DJF" -> R.string.name_djf
                "DKK" -> R.string.name_dkk
                "DOP" -> R.string.name_dop
                "DZD" -> R.string.name_dzd
                "EGP" -> R.string.name_egp
                "ERN" -> R.string.name_ern
                "ETB" -> R.string.name_etb
                "EUR" -> R.string.name_eur
                "FJD" -> R.string.name_fjd
                "FKP" -> R.string.name_fkp
                "GBP" -> R.string.name_gbp
                "GEL" -> R.string.name_gel
                "GGP" -> R.string.name_ggp
                "GHS" -> R.string.name_ghs
                "GIP" -> R.string.name_gip
                "GMD" -> R.string.name_gmd
                "GNF" -> R.string.name_gnf
                "GTQ" -> R.string.name_gtq
                "GYD" -> R.string.name_gyd
                "HKD" -> R.string.name_hkd
                "HNL" -> R.string.name_hnl
                "HRK" -> R.string.name_hrk
                "HTG" -> R.string.name_htg
                "HUF" -> R.string.name_huf
                "IDR" -> R.string.name_idr
                "ILS" -> R.string.name_ils
                "IMP" -> R.string.name_imp
                "INR" -> R.string.name_inr
                "IQD" -> R.string.name_iqd
                "IRR" -> R.string.name_irr
                "ISK" -> R.string.name_isk
                "JEP" -> R.string.name_jep
                "JMD" -> R.string.name_jmd
                "JOD" -> R.string.name_jod
                "JPY" -> R.string.name_jpy
                "KES" -> R.string.name_kes
                "KGS" -> R.string.name_kgs
                "KHR" -> R.string.name_khr
                "KMF" -> R.string.name_kmf
                "KPW" -> R.string.name_kpw
                "KRW" -> R.string.name_krw
                "KWD" -> R.string.name_kwd
                "KYD" -> R.string.name_kyd
                "KZT" -> R.string.name_kzt
                "LAK" -> R.string.name_lak
                "LBP" -> R.string.name_lbp
                "LKR" -> R.string.name_lkr
                "LRD" -> R.string.name_lrd
                "LSL" -> R.string.name_lsl
                "LYD" -> R.string.name_lyd
                "MAD" -> R.string.name_mad
                "MDL" -> R.string.name_mdl
                "MGA" -> R.string.name_mga
                "MKD" -> R.string.name_mkd
                "MMK" -> R.string.name_mmk
                "MNT" -> R.string.name_mnt
                "MOP" -> R.string.name_mop
                "MRO" -> R.string.name_mro
                "MRU" -> R.string.name_mru
                "MUR" -> R.string.name_mur
                "MVR" -> R.string.name_mvr
                "MWK" -> R.string.name_mwk
                "MXN" -> R.string.name_mxn
                "MYR" -> R.string.name_myr
                "MZN" -> R.string.name_mzn
                "NAD" -> R.string.name_nad
                "NGN" -> R.string.name_ngn
                "NIO" -> R.string.name_nio
                "NOK" -> R.string.name_nok
                "NPR" -> R.string.name_npr
                "NZD" -> R.string.name_nzd
                "OMR" -> R.string.name_omr
                "PAB" -> R.string.name_pab
                "PEN" -> R.string.name_pen
                "PGK" -> R.string.name_pgk
                "PHP" -> R.string.name_php
                "PKR" -> R.string.name_pkr
                "PLN" -> R.string.name_pln
                "PYG" -> R.string.name_pyg
                "QAR" -> R.string.name_qar
                "RON" -> R.string.name_ron
                "RSD" -> R.string.name_rsd
                "RUB" -> R.string.name_rub
                "RWF" -> R.string.name_rwf
                "SAR" -> R.string.name_sar
                "SBD" -> R.string.name_sbd
                "SCR" -> R.string.name_scr
                "SDG" -> R.string.name_sdg
                "SEK" -> R.string.name_sek
                "SGD" -> R.string.name_sgd
                "SHP" -> R.string.name_shp
                "SLL" -> R.string.name_sll
                "SOS" -> R.string.name_sos
                "SRD" -> R.string.name_srd
                "SSP" -> R.string.name_ssp
                "STD" -> R.string.name_std
                "STN" -> R.string.name_stn
                "SVC" -> R.string.name_svc
                "SYP" -> R.string.name_syp
                "SZL" -> R.string.name_szl
                "THB" -> R.string.name_thb
                "TJS" -> R.string.name_tjs
                "TMT" -> R.string.name_tmt
                "TND" -> R.string.name_tnd
                "TOP" -> R.string.name_top
                "TRY" -> R.string.name_try
                "TTD" -> R.string.name_ttd
                "TWD" -> R.string.name_twd
                "TZS" -> R.string.name_tzs
                "UAH" -> R.string.name_uah
                "UGX" -> R.string.name_ugx
                "USD" -> R.string.name_usd
                "UYU" -> R.string.name_uyu
                "UZS" -> R.string.name_uzs
                "VEF" -> R.string.name_vef
                "VND" -> R.string.name_vnd
                "VUV" -> R.string.name_vuv
                "WST" -> R.string.name_wst
                "XAF" -> R.string.name_xaf
                "XAG" -> R.string.name_xag
                "XAU" -> R.string.name_xau
                "XCD" -> R.string.name_xcd
                "XDR" -> R.string.name_xdr
                "XOF" -> R.string.name_xof
                "XPD" -> R.string.name_xpd
                "XPF" -> R.string.name_xpf
                "XPT" -> R.string.name_xpt
                "YER" -> R.string.name_yer
                "ZAR" -> R.string.name_zar
                "ZMW" -> R.string.name_zmw
                "ZWL" -> R.string.name_zwl
                else -> return null
            }
        )
    }

    fun getFlag(context: Context): Drawable? {
        return ContextCompat.getDrawable(
            context, when (code) {
                "AED" -> R.drawable.flag_ae
                "AFN" -> R.drawable.flag_af
                "ALL" -> R.drawable.flag_al
                "AMD" -> R.drawable.flag_am
                "ANG" -> R.drawable.flag_nl
                "AOA" -> R.drawable.flag_ao
                "ARS" -> R.drawable.flag_ar
                "AUD" -> R.drawable.flag_au
                "AWG" -> R.drawable.flag_aw
                "AZN" -> R.drawable.flag_az
                "BAM" -> R.drawable.flag_ba
                "BBD" -> R.drawable.flag_bb
                "BDT" -> R.drawable.flag_bd
                "BGN" -> R.drawable.flag_bg
                "BHD" -> R.drawable.flag_bh
                "BIF" -> R.drawable.flag_bi
                "BMD" -> R.drawable.flag_bm
                "BND" -> R.drawable.flag_bn
                "BOB" -> R.drawable.flag_bo
                "BRL" -> R.drawable.flag_br
                "BSD" -> R.drawable.flag_bs
                "BTN" -> R.drawable.flag_bt
                "BWP" -> R.drawable.flag_bw
                "BYN" -> R.drawable.flag_by
                "BZD" -> R.drawable.flag_bz
                "CAD" -> R.drawable.flag_ca
                "CDF" -> R.drawable.flag_cd
                "CHF" -> R.drawable.flag_ch
                "CLF" -> R.drawable.flag_cl
                "CLP" -> R.drawable.flag_cl
                "CNH" -> R.drawable.flag_cn
                "CNY" -> R.drawable.flag_cn
                "COP" -> R.drawable.flag_co
                "CRC" -> R.drawable.flag_cr
                "CUC" -> R.drawable.flag_cu
                "CUP" -> R.drawable.flag_cu
                "CVE" -> R.drawable.flag_cv
                "CZK" -> R.drawable.flag_cz
                "DJF" -> R.drawable.flag_dj
                "DKK" -> R.drawable.flag_dk
                "DOP" -> R.drawable.flag_do
                "DZD" -> R.drawable.flag_dz
                "EGP" -> R.drawable.flag_eg
                "ERN" -> R.drawable.flag_er
                "ETB" -> R.drawable.flag_et
                "EUR" -> R.drawable.flag_eu
                "FJD" -> R.drawable.flag_fj
                "FKP" -> R.drawable.flag_fk
                "GBP" -> R.drawable.flag_gb
                "GEL" -> R.drawable.flag_ge
                "GGP" -> R.drawable.flag_gg
                "GHS" -> R.drawable.flag_gh
                "GIP" -> R.drawable.flag_gi
                "GMD" -> R.drawable.flag_gm
                "GNF" -> R.drawable.flag_gn
                "GTQ" -> R.drawable.flag_gt
                "GYD" -> R.drawable.flag_gy
                "HKD" -> R.drawable.flag_hk
                "HNL" -> R.drawable.flag_hn
                "HRK" -> R.drawable.flag_hr
                "HTG" -> R.drawable.flag_ht
                "HUF" -> R.drawable.flag_hu
                "IDR" -> R.drawable.flag_id
                "ILS" -> R.drawable.flag_il
                "IMP" -> R.drawable.flag_im
                "INR" -> R.drawable.flag_in
                "IQD" -> R.drawable.flag_iq
                "IRR" -> R.drawable.flag_ir
                "ISK" -> R.drawable.flag_is
                "JEP" -> R.drawable.flag_je
                "JMD" -> R.drawable.flag_jm
                "JOD" -> R.drawable.flag_jo
                "JPY" -> R.drawable.flag_jp
                "KES" -> R.drawable.flag_ke
                "KGS" -> R.drawable.flag_kg
                "KHR" -> R.drawable.flag_kh
                "KMF" -> R.drawable.flag_km
                "KPW" -> R.drawable.flag_kp
                "KRW" -> R.drawable.flag_kr
                "KWD" -> R.drawable.flag_kw
                "KYD" -> R.drawable.flag_ky
                "KZT" -> R.drawable.flag_kz
                "LAK" -> R.drawable.flag_la
                "LBP" -> R.drawable.flag_lb
                "LKR" -> R.drawable.flag_lk
                "LRD" -> R.drawable.flag_lr
                "LSL" -> R.drawable.flag_ls
                "LYD" -> R.drawable.flag_ly
                "MAD" -> R.drawable.flag_ma
                "MDL" -> R.drawable.flag_md
                "MGA" -> R.drawable.flag_mg
                "MKD" -> R.drawable.flag_mk
                "MMK" -> R.drawable.flag_mm
                "MNT" -> R.drawable.flag_mn
                "MOP" -> R.drawable.flag_mo
                "MRO" -> R.drawable.flag_mr
                "MRU" -> R.drawable.flag_mr
                "MUR" -> R.drawable.flag_mu
                "MVR" -> R.drawable.flag_mv
                "MWK" -> R.drawable.flag_mw
                "MXN" -> R.drawable.flag_mx
                "MYR" -> R.drawable.flag_my
                "MZN" -> R.drawable.flag_mz
                "NAD" -> R.drawable.flag_na
                "NGN" -> R.drawable.flag_ng
                "NIO" -> R.drawable.flag_ni
                "NOK" -> R.drawable.flag_no
                "NPR" -> R.drawable.flag_np
                "NZD" -> R.drawable.flag_nz
                "OMR" -> R.drawable.flag_om
                "PAB" -> R.drawable.flag_pa
                "PEN" -> R.drawable.flag_pe
                "PGK" -> R.drawable.flag_pg
                "PHP" -> R.drawable.flag_ph
                "PKR" -> R.drawable.flag_pk
                "PLN" -> R.drawable.flag_pl
                "PYG" -> R.drawable.flag_py
                "QAR" -> R.drawable.flag_qa
                "RON" -> R.drawable.flag_ro
                "RSD" -> R.drawable.flag_rs
                "RUB" -> R.drawable.flag_ru
                "RWF" -> R.drawable.flag_rw
                "SAR" -> R.drawable.flag_sa
                "SBD" -> R.drawable.flag_sb
                "SCR" -> R.drawable.flag_sc
                "SDG" -> R.drawable.flag_sd
                "SEK" -> R.drawable.flag_se
                "SGD" -> R.drawable.flag_sg
                "SHP" -> R.drawable.flag_sh
                "SLL" -> R.drawable.flag_sl
                "SOS" -> R.drawable.flag_so
                "SRD" -> R.drawable.flag_sr
                "SSP" -> R.drawable.flag_ss
                "STD" -> R.drawable.flag_st
                "STN" -> R.drawable.flag_st
                "SVC" -> R.drawable.flag_sv
                "SYP" -> R.drawable.flag_sy
                "SZL" -> R.drawable.flag_sz
                "THB" -> R.drawable.flag_th
                "TJS" -> R.drawable.flag_tj
                "TMT" -> R.drawable.flag_tm
                "TND" -> R.drawable.flag_tn
                "TOP" -> R.drawable.flag_to
                "TRY" -> R.drawable.flag_tr
                "TTD" -> R.drawable.flag_tt
                "TWD" -> R.drawable.flag_tw
                "TZS" -> R.drawable.flag_tz
                "UAH" -> R.drawable.flag_ua
                "UGX" -> R.drawable.flag_ug
                "USD" -> R.drawable.flag_us
                "UYU" -> R.drawable.flag_uy
                "UZS" -> R.drawable.flag_uz
                "VEF" -> R.drawable.flag_ve
                "VND" -> R.drawable.flag_vn
                "VUV" -> R.drawable.flag_vu
                "WST" -> R.drawable.flag_ws
                "YER" -> R.drawable.flag_ye
                "ZAR" -> R.drawable.flag_za
                "ZMW" -> R.drawable.flag_zm
                "ZWL" -> R.drawable.flag_zw
                else -> R.drawable.flag_unknown
            }
        )
    }
}